#!/usr/local/bin/python

"""This wonderful python module was written by:
	Andy Dustman <andy@ccmsd.chem.uga.edu>
	             <dustman@athensnet.com>

Copyright (C) 1997. Please distribute widely."""

import hashcash,shelve

error = 'bank.error'

# Every good bank has a clock...
def today(): from time import time; return "%05d"%(time()/3600/24)

class Bank:
    """A bank is where you spend money."""
    def __init__(self, name, bits, lifetime):
        self.name = name
	self.bits = bits
	self.lifetime = lifetime
	self.dict = shelve.open(name+'.bank','cw')

    def redeem(self, h, bits=None):
	"""Reedeem a piece of hashcash."""
	if not bits: bits = self.bits
	gotbits = hashcash.count_collision_bits(self.name,h) 
	if gotbits < bits:
	    raise error, "%d-bit collision, wanted %d bits" % \
		(gotbits, bits)
	if not hashcash.still_valid(h,self.lifetime):
	    raise error, "Validity period expired"
	if self.dict.has_key(h):
	    raise error, "Coin already spent"
	self.dict[h] = None

    def __del__(self):
	for h in self.dict.keys():
	    if not hashcash.still_valid(h,self.lifetime):
		del self.dict[h]
	try: self.dict.reorganize()
	except AttributeError: print "I guess you don't have gdbmmodule."

